SystemOrganization addCategory: #Poo!

Object subclass: #BancoDeDados
	instanceVariableNames: 'cursos usuarios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!BancoDeDados commentStamp: 'FA 5/12/2013 18:47' prior: 0!
Banco que guarda cursos, usuarios e atraves dela que pesquisas sao feitas!

!BancoDeDados methodsFor: 'adding' stamp: 'tgn 5/12/2013 17:21'!
adicionaCurso: curso
	
	^cursos add: curso! !

!BancoDeDados methodsFor: 'adding' stamp: 'FA 5/12/2013 13:33'!
adicionaUsuario: usuario

	^usuarios add: (usuario login), '#',(usuario senha) -> usuario! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 20:31'!
cursos
	^cursos! !

!BancoDeDados methodsFor: 'accessing' stamp: 'tgn 5/13/2013 18:36'!
devolveAulasContendoOConteudo: string
	| res |
	res := Set new.
	cursos do: [ 
				:curso  |  (curso disciplinas) do: [ 
			 		:disciplina | (disciplina aulas) do: [
						:aula | 
							(aula temConteudosContendo: string)
								ifTrue: [
									res add: aula.
								]
						]
					]
				].
	^ res	 ! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 20:30'!
devolveAulasDeNome: nome
	| res |
	res := Set new.
	cursos do: [ 
				:curso  |  (curso disciplinas) do: [ 
			 		:disciplina | (disciplina aulas) do: [
						:aula | (aula nome = nome)
								ifTrue: [ res add: aula ]
						]
					]
				].
	^ res	 ! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 20:33'!
devolveConteudosContendo: string
	| res |
	res := Set new.
	cursos do: [ 
				:curso  |  (curso disciplinas) do: [ 
			 		:disciplina | (disciplina aulas) do: [
						:aula | 
							res addAll: (aula devolveConteudosContendo: string)
						]
					]
				].
	^ res	 ! !

!BancoDeDados methodsFor: 'accessing' stamp: 'tgn 5/12/2013 17:21'!
devolveCursosDeNome: nome 

	| res |
	res := Set new.
	cursos do: [ :curso  |  ((curso nome) = nome) 
		                               ifTrue: [ res add: curso ] ].
	^ res	 
	! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 18:36'!
devolveDisciplinasDeNome: nome
	| res |
	res := Set new.
	cursos do: [ :curso  |  (curso disciplinas) do: 
			     					[ :disciplina | ((disciplina nome) = nome) 
		                              					 ifTrue: [ res add: disciplina ] 
							      ]
	                 ].
	^ res	 ! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 20:30'!
devolveTurmasDeNome: nome
	| res |
	res := Set new.
	cursos do: [ 
				:curso  |  (curso disciplinas) do: [ 
			 		:disciplina | (disciplina turmas) do: [
						:turma | (turma nome = nome)
								ifTrue: [ res add: turma ]
						]
					]
				].
	^ res	 ! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 17:43'!
devolveUsuarioDeLogin: login eSenha: senha

	[ ^ usuarios at: (login,'#',senha) ]
	on: Exception
	do: [ ^ nil. ]	 
	! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 18:02'!
devolveUsuariosDeNome: nome
	| res |
	res := Set new.
	usuarios do: [ :usuario  |  ((usuario nome) = nome) 
		                               ifTrue: [ res add: usuario ] ].
	^ res	 ! !

!BancoDeDados methodsFor: 'initialize-release' stamp: 'tgn 5/12/2013 17:22'!
initialize
	cursos := Set new.
	usuarios := Dictionary new.
	^self! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 19:28'!
procuraPorConteudoContendo: string
	"| res |
	res := Set new.
	usuarios do: [ :usuario  |  ((usuario nome) = nome) 
		                               ifTrue: [ res add: usuario ] ].
	^ res	 "! !

!BancoDeDados methodsFor: 'accessing' stamp: 'FA 5/12/2013 16:28'!
usuarios
	^ usuarios! !

Object subclass: #Login
	instanceVariableNames: 'loggedUser systemUsers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

Login class
	instanceVariableNames: 'uniqueInstance'!

!Login commentStamp: 'BCM 5/5/2013 20:30' prior: 0!
This class logs in the user in the system!

Login class
	instanceVariableNames: 'uniqueInstance'!

!Login class methodsFor: 'as yet unclassified' stamp: 'FM 5/11/2013 09:55'!
new
	self error: 'You should uniqueInstance to get the unique instance'! !

!Login class methodsFor: 'as yet unclassified' stamp: 'FM 5/11/2013 09:55'!
reset
	uniqueInstance:=nil.! !

!Login class methodsFor: 'as yet unclassified' stamp: 'FM 5/11/2013 09:54'!
singleton
	"Create an uniqueInstance"
	uniqueInstance isNil ifTrue: [ ^uniqueInstance:= self basicNew initialize].
	^uniqueInstance.! !

!Login methodsFor: 'adding' stamp: 'FM 5/11/2013 12:34'!
addLoggedUser: anUser
	"Adding an user in the list of logged user"
	loggedUser add: anUser! !

!Login methodsFor: 'adding' stamp: 'FM 5/11/2013 13:12'!
addSystemUsers: anUser
	"Adding an user in the list of user of the System. 
	If users alread exist return error"
	systemUsers add: anUser! !

!Login methodsFor: 'initialize-release' stamp: 'FM 5/11/2013 13:06'!
initialize
	self instanceLoggedUser.
	self instanceSystemUsers.! !

!Login methodsFor: 'initialize-release' stamp: 'FM 5/11/2013 16:54'!
instanceLoggedUser
	loggedUser := OrderedCollection new.! !

!Login methodsFor: 'initialize-release' stamp: 'FM 5/11/2013 15:55'!
instanceSystemUsers
	"Create the collection to Users of the Systems"
	systemUsers := OrderedCollection new.! !

!Login methodsFor: 'comparing' stamp: 'BCM 5/12/2013 00:27'!
isLoggedUser: anUser 
	"Verify if an user is logged in the System"
	loggedUser
		do: [:element | element username = anUser username
				ifTrue: [^ true]].
	^ false! !

!Login methodsFor: 'comparing' stamp: 'FM 5/12/2013 12:28'!
isSystemUsers: anUser 
	"If to find return true else false"
	systemUsers
		do: [:element | element username = anUser username
				ifTrue: [^ true]].
	^ false! !

!Login methodsFor: 'accessing' stamp: 'FM 5/9/2013 19:58'!
loggedUser
	"Return a list of logged user"
	^ loggedUser! !

!Login methodsFor: 'adding' stamp: 'FM 5/11/2013 16:50'!
login: infoLogin
	
	"Search an user with the same credentials contained in infoLogin. 
	infoLogin is Array with 'unsername' and 'password'. 
	Add user in the list logged user.
	Return the Object of anUser"
	
	| client |
	client := (self searchSystemUsers: (infoLogin at:1)).
	client  isNil ifFalse:[	
				(client password = (infoLogin at:2)) 
					ifTrue:[ self addLoggedUser:client. ^client]].
	^nil! !

!Login methodsFor: 'removing' stamp: 'FM 5/11/2013 16:28'!
removeLoggedUser: anUser
	"Remove the logged user from the system"
	loggedUser remove: anUser ifAbsent: ['User absent'].! !

!Login methodsFor: 'removing' stamp: 'FM 5/12/2013 14:07'!
removeSystemUsers: anUser
	"Remove the user of the system users"
	systemUsers remove: anUser ifAbsent: ['User absent'].! !

!Login methodsFor: 'searching' stamp: 'FM 5/12/2013 20:34'!
searchSystemUsers: username
	systemUsers do: [ :element | ( (element username) = username)
                                       ifTrue: [^element]].
	^nil! !

!Login methodsFor: 'accessing' stamp: 'FM 5/11/2013 13:03'!
systemUsers
	"Get the Users of the Systems"
	^systemUsers! !

Object subclass: #Material
	instanceVariableNames: 'type title description author url topic tag creationDate lastUpdateDate license owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Material commentStamp: 'BCM 5/5/2013 18:17' prior: 0!
Class that represents a Material!

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
author
	^ author! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
author: anObject
	author := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
creationDate
	^ creationDate! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
creationDate: anObject
	creationDate := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
description
	^ description! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
description: anObject
	description := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
lastUpdateDate
	^ lastUpdateDate! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
lastUpdateDate: anObject
	lastUpdateDate := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
license
	^ license! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
license: anObject
	license := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
owner
	^ owner! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
owner: anObject
	owner := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
tag
	^ tag! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
tag: anObject
	tag := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
title
	^ title! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
title: anObject
	title := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
topic
	^ topic! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
topic: anObject
	topic := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
type
	^ type! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
type: anObject
	type := anObject! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
url
	^ url! !

!Material methodsFor: 'accessing' stamp: ''' 6/29/2013 18:10'!
url: anObject
	url := anObject! !

Object subclass: #MaterialManager
	instanceVariableNames: 'materialList reviewList materialListOfModerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

MaterialManager class
	instanceVariableNames: 'uniqueInstance'!

!MaterialManager commentStamp: 'BCM 5/12/2013 01:44' prior: 0!
Class that manages all the materials in the system!

MaterialManager class
	instanceVariableNames: 'uniqueInstance'!

!MaterialManager class methodsFor: 'as yet unclassified' stamp: 'FM 5/12/2013 16:16'!
new
	self error: 'You should uniqueInstance to get the unique instance'! !

!MaterialManager class methodsFor: 'as yet unclassified' stamp: 'FM 5/12/2013 16:18'!
reset
	uniqueInstance := nil.! !

!MaterialManager class methodsFor: 'as yet unclassified' stamp: 'FM 5/12/2013 17:08'!
singleton
	"Create an uniqueInstance"
	uniqueInstance isNil ifTrue: [^uniqueInstance:= self basicNew initialize].
	^uniqueInstance! !

!MaterialManager methodsFor: 'adding' stamp: 'FM 5/12/2013 19:48'!
addMaterial: aMaterial 
	"Add a material to the list if it doesnt already exists"
	(self listMaterial: materialList contains: aMaterial)
		ifFalse: [materialList add: aMaterial]! !

!MaterialManager methodsFor: 'adding' stamp: 'FM 5/13/2013 02:14'!
addMaterialListOfModerator: aMaterial
	"Adding a Material if not exist"
	(self listMaterial: materialListOfModerator contains: aMaterial) ifFalse:[
	materialListOfModerator add:  aMaterial.]! !

!MaterialManager methodsFor: 'adding' stamp: 'FM 5/13/2013 03:01'!
calculateRank: aMaterial 
	"Calculate the average score of the specified material"
	| total count |
	total := 0.
	count := 0.
	reviewList
		do: [:review | review material = aMaterial
				ifTrue: [count := count + 1.
					total := total + review score]].
	count ~= 0
		ifTrue: [total := total / (count * 1.0)].
	^ total! !

!MaterialManager methodsFor: 'adding' stamp: 'BCM 5/12/2013 00:15'!
createMaterial: aMaterial 
	"Create the material and add it to the database"
	self addMaterial: aMaterial! !

!MaterialManager methodsFor: 'searching' stamp: 'FM 5/13/2013 04:07'!
findMaterialBy: aCriteria value: aValue 
	"Find a material by the specified criteria (type, owner, etc) of the specified value"
	| list |
	list := OrderedCollection new.
	
	aCriteria = 'type'
	ifTrue:[
		materialList
			do: [:material | (material type = aValue)
				ifTrue: [list add: material]].
	].
	aCriteria = 'author'
	ifTrue:[
		materialList
			do: [:material | (material author = aValue)
				ifTrue: [list add: material]].
	].
	aCriteria = 'creationDate'
	ifTrue:[
		materialList
			do: [:material | (material creationDate = aValue)
				ifTrue: [list add: material]].
	].
	aCriteria = 'description'
	ifTrue:[
		materialList
			do: [:material | (material description = aValue)
				ifTrue: [list add: material]].
	].
	aCriteria = 'lastUpdateDate'
	ifTrue:[
		materialList
			do: [:material | (material lastUpdateDate = aValue)
				ifTrue: [list add: material]].
	].	
	aCriteria = 'license'
	ifTrue:[
		materialList
			do: [:material | (material license = aValue)
				ifTrue: [list add: material]].
	].	
	aCriteria = 'owner'
	ifTrue:[
		materialList
			do: [:material | (material owner = aValue)
				ifTrue: [list add: material]].
	].	
	aCriteria = 'tag'
	ifTrue:[
		materialList
			do: [:material | (material tag = aValue)
				ifTrue: [list add: material]].
	].	
	aCriteria = 'title'
	ifTrue:[
		materialList
			do: [:material | (material title = aValue)
				ifTrue: [list add: material]].
	].
	aCriteria = 'topic'
	ifTrue:[
		materialList
			do: [:material | (material topic = aValue)
				ifTrue: [list add: material]].
	].
^ list! !

!MaterialManager methodsFor: 'initialize-release' stamp: 'FM 5/13/2013 00:41'!
initialize
	"Initialization of class"
	materialList := OrderedCollection new.
	reviewList := OrderedCollection new.
	materialListOfModerator := OrderedCollection new.! !

!MaterialManager methodsFor: 'accessing' stamp: 'FM 5/12/2013 19:47'!
listMaterial: collection contains: anMaterial
	collection do: [: element | 
			(element url = anMaterial url) 
			ifTrue: [^true] ].
	^false! !

!MaterialManager methodsFor: 'accessing' stamp: 'FM 5/13/2013 11:26'!
listMaterialsOfUser: anUser 
	"List the materials of the specified User"
	| list |
	list := OrderedCollection new.
	materialList
		do: [:material | material owner = anUser username
				ifTrue: [list add: material]].
	^ list! !

!MaterialManager methodsFor: 'accessing' stamp: 'FM 5/12/2013 16:43'!
materialList
	^materialList! !

!MaterialManager methodsFor: 'accessing' stamp: 'FM 5/13/2013 00:39'!
materialListOfModerator
	^materialListOfModerator! !

!MaterialManager methodsFor: 'removing' stamp: 'BCM 5/12/2013 00:15'!
removeMaterial: aMaterial 
	"Remove the specified material if it exists"
	(materialList includes: aMaterial)
		ifTrue: [materialList remove: aMaterial]! !

!MaterialManager methodsFor: 'removing' stamp: 'FM 5/13/2013 02:26'!
removeMaterialListOfModerator: aMaterial
	materialListOfModerator remove:  aMaterial ifAbsent:[ "Material not found"].! !

!MaterialManager methodsFor: 'accessing' stamp: 'FM 5/13/2013 02:55'!
reviewList
	^reviewList! !

!MaterialManager methodsFor: 'adding' stamp: 'FM 5/13/2013 14:19'!
reviewMaterial: aMaterial score: aScore 
	"Review the specified material"
	reviewList add: (Review new material: aMaterial score: aScore comment: '').! !

!MaterialManager methodsFor: 'adding' stamp: 'FM 5/13/2013 02:41'!
reviewMaterial: aMaterial score: aScore comment: aComment
	"Review the specified material"
	reviewList add: (Review new material: aMaterial score: aScore comment: aComment).! !

!MaterialManager methodsFor: 'adding' stamp: 'FM 5/13/2013 13:30'!
updateMaterial: aMaterial 
	"Update the specified material"
	self removeMaterial: aMaterial.
	self addMaterial: aMaterial.! !

Object subclass: #Review
	instanceVariableNames: 'material score comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Review commentStamp: 'BCM 5/12/2013 01:18' prior: 0!
This class represents a Review attributed to a material!

!Review methodsFor: 'accessing' stamp: 'BCM 5/12/2013 01:29'!
comment
	"Get the comment associated with this review"
	^ comment! !

!Review methodsFor: 'adding' stamp: 'BCM 5/12/2013 01:27'!
comment: aComment 
	"Set the comment associated with this review"
	comment := aComment! !

!Review methodsFor: 'accessing' stamp: 'BCM 5/12/2013 01:25'!
material
	"Get the material associated with this review"
	^ material! !

!Review methodsFor: 'adding' stamp: 'BCM 5/12/2013 01:24'!
material: aMaterial 
	"Set the material associated with this review"
	material := aMaterial! !

!Review methodsFor: 'adding' stamp: 'FM 5/13/2013 02:49'!
material: aMaterial score: aScore comment:aComment
	self material: aMaterial.
	self score: aScore.
	self comment: aComment.! !

!Review methodsFor: 'accessing' stamp: 'BCM 5/12/2013 01:29'!
score
	"Get the score associated with this review"
	^ score! !

!Review methodsFor: 'adding' stamp: 'BCM 5/12/2013 01:26'!
score: aScore 
	"Set the score (1 to 5) for this review"
	score := aScore! !

Object subclass: #System
	instanceVariableNames: 'admin bancoDeDados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!System commentStamp: 'tgn 5/11/2013 15:59' prior: 0!
Classe de acesso ao sistema!

!System methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 15:57'!
acessarComNome: nomeAdmin eSenha: senhaAdmin
	"Tenta acessar o sistema"

	('admin' compare: nomeAdmin) = 2
		ifTrue: [ ^ ('admin' compare: senhaAdmin) = 2 ]
		ifFalse: [ ^ false ].
					
		! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 21:28'!
adicionaAluno: aluno naTurma: turmaNome
	| turmas |
	turmas := bancoDeDados devolveTurmasDeNome: turmaNome.
	turmas do: [ :turma | turma adicionaAluno: aluno ].! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 21:27'!
adicionaConteudo: conteudo naAula: aulaNome
	| aulas |
	aulas := bancoDeDados devolveAulasDeNome: aulaNome.
	aulas do: [ :aula | aula adicionaConteudo: conteudo ].! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 21:33'!
adicionarModerador: moderadorNome noCursoDeNome: cursoNome	
	| cursos moderadores |
	cursos := bancoDeDados devolveCursosDeNome: cursoNome.
	moderadores := bancoDeDados devolveUsuariosDeNome: moderadorNome.
	cursos do: [ :curso | moderadores do: [ :moderador |
			curso adicionaModerador: moderador ] ].! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/13/2013 18:54'!
avaliarConteudo: conteudoNome peloUsuario: usuario comNota:nota
	| conteudos aulas |
	conteudos := bancoDeDados devolveConteudosContendo: conteudoNome.
	conteudos do: [ :conteudo |
		aulas := bancoDeDados devolveAulasContendoOConteudo: (conteudo nome).
		aulas do: [ :aula |
			(aula eModerador: usuario)
				ifTrue: [
					conteudo adicionaNotaModerador: nota.
				]
				ifFalse: [
					conteudo adicionaNota: nota.
				]
			]
		].
		! !

!System methodsFor: 'system primitives' stamp: ''' 6/29/2013 18:20'!
criarAulaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores naDisciplinaDeNome: disciplinaNome
	| aula disciplina |
	aula := Lecture new.
	aula nome: nome.
	aula descricao: descricao.
	aula responsavel: responsavel.
	moderadores do: [ :moderador | 	aula adicionaModerador: moderador ].
	disciplina :=	bancoDeDados devolveDisciplinasDeNome: disciplinaNome.
	disciplina adicionaAula: aula.! !

!System methodsFor: 'system primitives' stamp: ''' 6/29/2013 18:21'!
criarCursoComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores
	| curso |
	curso := Program new.
	curso nome: nome.
	curso descricao: descricao.
	curso responsavel: responsavel.
	moderadores do: [ :moderador | 	curso adicionaModerador: moderador ].
	bancoDeDados adicionaCurso: curso.! !

!System methodsFor: 'system primitives' stamp: ''' 6/29/2013 18:21'!
criarDisciplinaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores noCursoDeNome: cursoNome
	| disciplina cursos |
	disciplina := Course new.
	disciplina nome: nome.
	disciplina descricao: descricao.
	disciplina responsavel: responsavel.
	moderadores do: [ :moderador | 	disciplina adicionaModerador: moderador ].
	cursos :=	bancoDeDados devolveCursosDeNome: cursoNome.
	cursos do: [ :curso | curso adicionaDisciplina: disciplina ].! !

!System methodsFor: 'system primitives' stamp: ''' 6/29/2013 18:21'!
criarTurmaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores naDisciplinaDeNome: disciplinaNome
	| turma disciplinas |
	turma := Classroom new.
	turma nome: nome.
	turma descricao: descricao.
	turma responsavel: responsavel.
	moderadores do: [ :moderador | 	turma adicionaModerador: moderador ].
	disciplinas := bancoDeDados devolveDisciplinasDeNome: disciplinaNome.
	disciplinas do: [ :disciplina | disciplina adicionaTurma: turma ].
	! !

!System methodsFor: 'system primitives' stamp: 'FA 5/13/2013 19:54'!
criarUsuario: nome comSenha: senha eLogin: login
	^bancoDeDados adicionaUsuario: (admin criarUsuarioComNome: nome eSenha: senha eLogin: login).! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/13/2013 19:56'!
deletaConteudo: nome
	| listaConteudo listaAulas |
	listaConteudo := bancoDeDados devolveConteudosContendo: nome.
	listaConteudo do: [ :conteudo | 
		listaAulas := bancoDeDados devolveAulasContendoOConteudo: (conteudo titulo).
		listaAulas do: [ :aula | ( aula conteudos) remove: conteudo ifAbsent: [] ] ].! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/13/2013 19:47'!
deletaUsuarioComNome: nome
	| listaUsuarios |
	listaUsuarios := bancoDeDados devolveUsuariosDeNome: nome.
	listaUsuarios do: [ :usuario | (bancoDeDados usuarios) remove: usuario ifAbsent: [] ].! !

!System methodsFor: 'initialize-release' stamp: ''' 6/29/2013 18:22'!
initialize
	admin := Administrator new.
	bancoDeDados := BancoDeDados new.
	^self! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/13/2013 18:59'!
mediaDeNotaDeModeradoresDoConteudo: conteudoNome
	| conteudos res |
	conteudos := bancoDeDados devolveConteudosContendo: conteudoNome.
	res := Set new.
	conteudos do: [ :conteudo | res add: (conteudo mediaDasNotasModerador) ].
		! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/13/2013 18:56'!
mediaDeNotaDoConteudo: conteudoNome
	| conteudos res |
	conteudos := bancoDeDados devolveConteudosContendo: conteudoNome.
	res := Set new.
	conteudos do: [ :conteudo | res add: (conteudo mediaDasNotas) ].
		! !

!System methodsFor: 'system primitives' stamp: 'tgn 5/13/2013 18:32'!
usuario: nome agoraModeraOTopico: topico
	| usuarios |
	usuarios := bancoDeDados devolveUsuariosDeNome: nome.
	usuarios do: [ :usuario | topico adicionaModerador: usuario ].

	! !

Object subclass: #Topic
	instanceVariableNames: 'name creationData description moderators responsible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

Topic subclass: #Classroom
	instanceVariableNames: 'students instructor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Classroom methodsFor: 'adding' stamp: ''' 6/29/2013 17:37'!
addStudent: aStudent
	^students add: aStudent.    ! !

!Classroom methodsFor: 'initialize' stamp: ''' 6/29/2013 17:39'!
initialize	
	students  := Set new.	
	^self! !

!Classroom methodsFor: 'accessing' stamp: ''' 6/29/2013 17:37'!
instructor
	^ instructor! !

!Classroom methodsFor: 'accessing' stamp: ''' 6/29/2013 17:37'!
instructor: anObject
	instructor := anObject! !

!Classroom methodsFor: 'accessing' stamp: ''' 6/29/2013 17:37'!
students
	^ students! !

!Classroom methodsFor: 'accessing' stamp: ''' 6/29/2013 17:37'!
students: anObject
	students := anObject! !

Topic subclass: #Course
	instanceVariableNames: 'lecturs classrooms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Course commentStamp: '<historical>' prior: 0!
Uma Disciplina do sistema!

!Course methodsFor: 'adicionando' stamp: ''' 6/29/2013 17:55'!
addClassroom: aClassroom
	^classrooms  add: aClassroom.! !

!Course methodsFor: 'adicionando' stamp: ''' 6/29/2013 17:55'!
addLecture: aLecture
	^lecturs add: aLecture.  ! !

!Course methodsFor: 'accessing' stamp: ''' 6/29/2013 17:55'!
classrooms
	^ classrooms! !

!Course methodsFor: 'accessing' stamp: ''' 6/29/2013 17:55'!
classrooms: anObject
	classrooms := anObject! !

!Course methodsFor: 'initialize-release' stamp: ''' 6/29/2013 17:55'!
initialize
	lecturs  := Set new.
	classrooms  := Set new.
	^self! !

!Course methodsFor: 'accessing' stamp: ''' 6/29/2013 17:55'!
lecturs
	^ lecturs! !

!Course methodsFor: 'accessing' stamp: ''' 6/29/2013 17:55'!
lecturs: anObject
	lecturs := anObject! !

Topic subclass: #Lecture
	instanceVariableNames: 'materials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Lecture commentStamp: 'HGPL 5/11/2013 16:05' prior: 0!
Uma Aula do sistema!

!Lecture methodsFor: 'adding' stamp: ''' 6/29/2013 17:54'!
addMaterial: aMaterial
	materials add: aMaterial.    ! !

!Lecture methodsFor: 'initialize-release' stamp: ''' 6/29/2013 17:49'!
initialize
	materials := Set new.
	^self
	
! !

!Lecture methodsFor: 'accessing' stamp: ''' 6/29/2013 17:51'!
materials
	^ materials! !

!Lecture methodsFor: 'accessing' stamp: ''' 6/29/2013 17:51'!
materials: anObject
	materials := anObject! !

Topic subclass: #Program
	instanceVariableNames: 'courses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Program methodsFor: 'adding' stamp: ''' 6/29/2013 18:01'!
addCourse: aCourse
	courses add: aCourse.  ! !

!Program methodsFor: 'accessing' stamp: ''' 6/29/2013 18:00'!
courses
	^ courses! !

!Program methodsFor: 'accessing' stamp: ''' 6/29/2013 18:00'!
courses: anObject
	courses := anObject! !

!Program methodsFor: 'initialize-release' stamp: ''' 6/29/2013 18:01'!
initialize	
	courses  := Set new.	
	^self! !

!Topic methodsFor: 'system primitives' stamp: ''' 6/29/2013 17:15'!
addModerator: aModerator
	"Add a new moderator"
	
	^ moderators add: aModerator ! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
creationData 
	^ creationData ! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
creationData: anObject
	"Set the value of creationData"

	creationData := anObject! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:31'!
description
	^ description! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
description: anObject
	"Set the value of description"

	description := anObject! !

!Topic methodsFor: 'initialize' stamp: ''' 6/29/2013 17:20'!
initialize 
	"Initialize a new Topic."
	name := 'Nameless Topic'.
	creationData := DateAndTime now.
	moderators := Set new.
	^ self 	
	! !

!Topic methodsFor: 'system primitives' stamp: ''' 6/29/2013 17:16'!
isModerator: anUser
	"Verify if an user is a moderator."
	^ moderators includes:  anUser ! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
moderators
	"Answer the value of moderators"

	^ moderators! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
moderators: anObject
	"Set the value of moderators"

	moderators := anObject! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:31'!
name
	^ name! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
name: anObject
	"Set the value of name"

	name := anObject! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
responsible
	"Answer the value of responsible"

	^ responsible! !

!Topic methodsFor: 'accessing' stamp: ''' 6/29/2013 17:17'!
responsible: anObject
	"Set the value of responsible"

	responsible := anObject! !

Object subclass: #User
	instanceVariableNames: 'username password email userId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!User commentStamp: 'BCM 4/15/2013 02:31' prior: 0!
Abstract class that represents the user of the system!

User subclass: #Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Administrator methodsFor: 'transform' stamp: 'FA 6/29/2013 21:00'!
changeCommonToModerator: anCommonUser 
	"Transform an Common User in Moderator."
	anCommonUser isCommon
		ifTrue: [
			  (UserManager singleton) removeSystemUsers: anCommonUser.
			^(UserManager singleton) createNewUser: Moderator username: anCommonUser username
				password: anCommonUser password email: anCommonUser email.
			].
		^nil! !

!Administrator methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:39'!
isAdministrator
	^true! !

!Administrator methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:37'!
isCommon
	^false! !

!Administrator methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:40'!
isModerator
	^false! !

User subclass: #Common
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Common methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:40'!
isAdministrator
	^false! !

!Common methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:40'!
isCommon
	^true! !

!Common methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:41'!
isModerator
	^false! !

User subclass: #Moderator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Moderator methodsFor: 'adding' stamp: 'FM 5/13/2013 01:02'!
approveMaterial: aMaterial
	"Adding in materialList"
	(UserManager singleton) createMaterial: aMaterial.! !

!Moderator methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:42'!
isAdministrator
	^false! !

!Moderator methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:41'!
isCommon
	^false! !

!Moderator methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:42'!
isModerator
	^true! !

!Moderator methodsFor: 'accessing' stamp: 'FM 5/13/2013 04:17'!
materialListOfModerator
	((UserManager singleton) isLoggedUser: self) ifTrue:[
	^ (MaterialManager singleton) materialListOfModerator.
	]! !

!User methodsFor: 'accessing' stamp: 'FM 5/11/2013 11:44'!
email
	"Answer the value of email"
	^ email! !

!User methodsFor: 'adding' stamp: 'register: 5/2/2013 22:49'!
email: anObject
	"Set the value of email"

	email := anObject! !

!User methodsFor: 'searching' stamp: 'FM 5/13/2013 13:32'!
findMaterialBy: aCriteria value: aValue
	^(MaterialManager singleton) findMaterialBy: aCriteria value: aValue.! !

!User methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:37'!
isAdministrator
	^self subclassResponsibility! !

!User methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:36'!
isCommon
	^self subclassResponsibility! !

!User methodsFor: 'comparing' stamp: 'register: 5/7/2013 22:39'!
isModerator
	^self subclassResponsibility! !

!User methodsFor: 'accessing' stamp: 'FM 5/11/2013 11:44'!
password
	"Answer the value of password"
	^ password! !

!User methodsFor: 'adding' stamp: 'register: 5/2/2013 22:49'!
password: anObject
	"Set the value of password"

	password := anObject! !

!User methodsFor: 'removing' stamp: 'FM 5/13/2013 13:03'!
removeMaterial: aMaterial
	"Remove the specified material this users"
	(aMaterial owner = self username) ifTrue:[
		(MaterialManager singleton) removeMaterial: aMaterial.
	]! !

!User methodsFor: 'adding' stamp: 'FM 5/13/2013 14:19'!
reviewMaterial: aMaterial score: score
	(MaterialManager singleton) reviewMaterial: aMaterial score: score! !

!User methodsFor: 'adding' stamp: 'FM 5/13/2013 02:38'!
reviewMaterial: aMaterial score: score comment: comment
	(MaterialManager singleton) reviewMaterial: aMaterial score: score comment: comment.! !

!User methodsFor: 'adding' stamp: 'FM 5/13/2013 13:59'!
updateMaterial: aMaterial
	"Update the Material."
	( ( (UserManager singleton) isLoggedUser: self ) & 
		( aMaterial owner = self username) & 
		((MaterialManager singleton) listMaterial: (MaterialManager singleton) materialList contains: aMaterial)
	) ifTrue:[ 
		(MaterialManager singleton) updateMaterial: aMaterial. 
	]! !

!User methodsFor: 'accessing' stamp: 'FM 5/11/2013 11:43'!
userId
	"Get the identify of user"
	^ userId.! !

!User methodsFor: 'adding' stamp: 'FM 5/10/2013 00:46'!
userId: userID
	"Set the identify of user"
	userId:= userID.
	! !

!User methodsFor: 'initialize-release' stamp: 'FM 5/10/2013 00:47'!
userRole: Role username: username password: password email:email
	"Creation of the User. In this case, Role are Administrator; Moderator and Common. 'Role' is the role of user in the System"
	^(Role new) username: username password: password email: email userId: 1.! !

!User methodsFor: 'initialize-release' stamp: 'FM 5/10/2013 00:54'!
userRole: Role username: username password: password email:email userId: userId
	"Creation of the User. In this case, Role are Administrator; Moderator and Common. 'Role' is the role of user in the System"
	^(Role new) username: username password: password email: email userId: userId.! !

!User methodsFor: 'accessing' stamp: 'FM 5/11/2013 11:44'!
username
	"Answer the value of username"
	^ username! !

!User methodsFor: 'adding' stamp: 'register: 5/2/2013 22:49'!
username: anObject
	"Set the value of username"

	username := anObject! !

!User methodsFor: 'adding' stamp: 'FA 6/29/2013 20:57'!
username: username password: password email:email 
	"Create the User paramenters"
	self username: username.
	self password: password.
	self email:email.
	^self! !

!User methodsFor: 'adding' stamp: 'FM 5/10/2013 00:49'!
username: username password: password email:email userId: userId
	"Create the User paramenters"
	self username: username.
	self password: password.
	self email:email.
	self userId: userId.
	^self! !

Object subclass: #UserManager
	instanceVariableNames: 'loginInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

UserManager class
	instanceVariableNames: 'uniqueInstance'!

!UserManager commentStamp: 'BCM 4/15/2013 02:33' prior: 0!
Manages users permissions!

UserManager class
	instanceVariableNames: 'uniqueInstance'!

!UserManager class methodsFor: 'as yet unclassified' stamp: 'register: 5/9/2013 00:52'!
new
	self error: 'You should uniqueInstance to get the unique instance'! !

!UserManager class methodsFor: 'as yet unclassified' stamp: 'register: 5/9/2013 00:57'!
reset
	uniqueInstance:=nil.! !

!UserManager class methodsFor: 'as yet unclassified' stamp: 'FM 5/11/2013 09:55'!
singleton
	"Create an uniqueInstance"
	uniqueInstance isNil ifTrue:[^uniqueInstance:= self basicNew initialize].
	^uniqueInstance! !

!UserManager methodsFor: 'adding' stamp: 'FM 5/11/2013 12:41'!
addLoggedUser: anUser
	"Adding an user in the list of logged user"
	loginInstance addLoggedUser: anUser.! !

!UserManager methodsFor: 'adding' stamp: 'FM 5/11/2013 13:17'!
addSystemUsers: anUser
	"Adding an user in the list of user of the Systems"
	loginInstance addSystemUsers: anUser.! !

!UserManager methodsFor: 'adding' stamp: 'FM 5/13/2013 14:20'!
anUser: anUser reviewMaterial: aMaterial score: score
	(self isLoggedUser: anUser) ifTrue:[
	anUser reviewMaterial: aMaterial score: score.]! !

!UserManager methodsFor: 'adding' stamp: 'FM 5/13/2013 04:10'!
anUser: anUser reviewMaterial: aMaterial score: score comment: comment
	(self isLoggedUser: anUser) ifTrue:[
	anUser reviewMaterial: aMaterial score: score comment: comment.]! !

!UserManager methodsFor: 'adding' stamp: 'FM 5/13/2013 01:04'!
createMaterial: aMaterial
	"Create a Material approved by Moderator."
	((MaterialManager singleton) listMaterial: ( self materialListOfModerator ) contains: aMaterial) ifTrue:[		
		(MaterialManager singleton) removeMaterialListOfModerator: aMaterial.
		(MaterialManager singleton) createMaterial: aMaterial.
	].! !

!UserManager methodsFor: 'creation-user' stamp: 'FA 6/29/2013 20:57'!
createNewUser: Role username: username password: password email: email
	"Create a new user in the system and Load the list logged User."
	| anUser |
	anUser:=User new userRole: Role username: username password: password email: email.
	(self userIsRegister: anUser) ifFalse:[
			self addSystemUsers: anUser. ^anUser].		
	^nil! !

!UserManager methodsFor: 'initialize-release' stamp: 'FM 5/11/2013 13:22'!
initialize
	Login reset.
	self instanceLogin! !

!UserManager methodsFor: 'initialize-release' stamp: 'FM 5/11/2013 13:22'!
instanceLogin
	loginInstance := Login singleton.
	! !

!UserManager methodsFor: 'comparing' stamp: 'FM 5/12/2013 19:11'!
isLoggedUser: anUser
 	"Verify if an user is logged in the System"
	^loginInstance isLoggedUser: anUser.! !

!UserManager methodsFor: 'accessing' stamp: 'FM 5/13/2013 11:30'!
listMaterialsOfUser: anUser
	(self isLoggedUser: anUser) ifTrue:[
	^(MaterialManager singleton) listMaterialsOfUser: anUser.
	]! !

!UserManager methodsFor: 'accessing' stamp: 'FM 5/11/2013 09:48'!
loggedUser
	"Return a list of logged user"
	^ loginInstance loggedUser.! !

!UserManager methodsFor: 'login' stamp: 'FM 5/11/2013 09:38'!
login: infoLogin
	^loginInstance login: infoLogin.
	! !

!UserManager methodsFor: 'accessing' stamp: 'FM 5/13/2013 00:55'!
materialListOfModerator
	^ (MaterialManager singleton) materialListOfModerator! !

!UserManager methodsFor: 'creation-user' stamp: 'FA 6/29/2013 20:56'!
register: infoUser
	"Register a new Common User. InfoUser is a Dictionary of the user's informations"
	^self createNewUser: Common username:  (infoUser at:'username') password: (infoUser at:'password') email: (infoUser at:'email')! !

!UserManager methodsFor: 'creation-user' stamp: 'FA 6/29/2013 21:00'!
register: infoUser role: Role
	"Register a new User with a specific role in the System. InfoUser #(username password email)"
	^self createNewUser: Role username: (infoUser at:'username') password: (infoUser at:'password') email: (infoUser at:'email').
	! !

!UserManager methodsFor: 'removing' stamp: 'FM 5/11/2013 12:37'!
removeLoggedUser: anUser
	"Remove the logged user from the system"
	loginInstance removeLoggedUser: anUser.! !

!UserManager methodsFor: 'removing' stamp: 'FM 5/13/2013 13:18'!
removeMaterial: aMaterial fromUser: anUser.
	"Remove a Material."
	(self isLoggedUser: anUser) ifTrue:[
		anUser removeMaterial: aMaterial.
	]! !

!UserManager methodsFor: 'removing' stamp: 'FM 5/12/2013 23:08'!
removeSystemUsers: anUser
	"Remove the user of the list system users"
	loginInstance removeSystemUsers: anUser.! !

!UserManager methodsFor: 'adding' stamp: 'FM 5/13/2013 04:15'!
submitMaterial: infoMaterial by: anUser
	(self isLoggedUser: anUser) ifTrue:[
	"Material is stored in the list of Topic."
	| material | 
	material := Material new.
	material author: (anUser username).
	material creationDate: (infoMaterial at: 'creationDate').
	material description: (infoMaterial at: 'description').
	material lastUpdateDate: (infoMaterial at: 'lastUpdateDate').
	material license: (infoMaterial at: 'license').
	material owner: (anUser username).
	material tag: (infoMaterial at: 'tag').
	material title: (infoMaterial at: 'title').
	material topic: (infoMaterial at: 'topic').
	material type: (infoMaterial at: 'type').
	material url: (infoMaterial at: 'url').
	
	(anUser isCommon) ifTrue:[
		(MaterialManager singleton) addMaterialListOfModerator: material.
	] ifFalse:[
		(MaterialManager singleton) createMaterial: material.
	].
	]! !

!UserManager methodsFor: 'accessing' stamp: 'FM 5/11/2013 13:29'!
systemUsers
	"Get the Users of the Systems"
	^loginInstance systemUsers.! !

!UserManager methodsFor: 'comparing' stamp: 'FM 5/11/2013 17:13'!
userIsRegister: anUser
 	"Verify if an user is register in the System."
	^loginInstance isSystemUsers: anUser.! !
